djangoapp/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('polls/', include('polls.urls')),
    path('admin/', admin.site.urls),
]

polls/urls.py
from django.urls import path

from . import views

app_name = 'polls'

urlpatterns = [
    # ex: /polls/
    path('', views.index, name='index'),
    # ex: /polls/5/
    path('<int:question_id>/', views.detail, name='detail'),
    # ex: /polls/5/results/
    path('<int:question_id>/results/', views.results, name='results'),
    # ex: /polls/5/vote/
    path('<int:question_id>/vote/', views.vote, name='vote'),

    path('login/', views.sign_in, name='login'),
    path('logout/', views.sign_out, name='logout'),
]

polls/models.py
import datetime
from django.db import models
from django.utils import timezone

# Create your models here.
class Question(models.Model):
    question_text = models.CharField(max_length = 200)
    pub_date = models.DateTimeField('date published')

    def __str__(self):
        return self.question_text
    
    def was_published_recently(self):
        return self.pub_date >= timezone.now() - datetime.timedelta(days = 1)

class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length = 200)
    votes = models.IntegerField(default = 0)

    def __str__(self):
        return self.choice_text

polls/forms.py
from django import forms

class LoginForm(forms.Form):
    username = forms.CharField(max_length = 30)
    password = forms.CharField(max_length = 30, widget = forms.PasswordInput)

polls/views.py
from django.http import HttpResponse, HttpResponseRedirect
from django.http import Http404
from django.template import loader
from django.shortcuts import render, get_object_or_404, redirect
from django.urls import reverse
from .forms import LoginForm
from django.contrib.auth import login, authenticate, logout
from django.contrib import messages

from .models import Question, Choice

# Create your views here.
def index(request):
    latest_question_list = Question.objects.order_by('-pub_date')[:30]
    context = {'latest_question_list': latest_question_list}
    return render(request, 'polls/index.html', context)
    # template = loader.get_template('polls/index.html')
    # context ={
    #     'latest_question_list': latest_question_list
    # }
    # return HttpResponse(template.render(context, request))
 

def detail(request, question_id):
    question = get_object_or_404(Question, pk = question_id)
    # try:
    #     question = Question.objects.get(pk = question_id)
    # except Question.DoesNotExist:
    #     raise Http404('Question does not exist')
    return render(request, 'polls/detail.html', {'question':question})

def results(request, question_id):
    response = "You're looking at the results of question %s."
    return HttpResponse(response % question_id)

def vote(request, question_id):
    question = get_object_or_404(Question, pk = question_id)
    try:
        selected_choice = question.choice_set.get(pk =request.POST['choice'])
    except (KeyError, Choice.DoesNotExist):
        return render(request, 'polls/detail.html', {
            'question': question,
            'error_message': 'You did not select a choice.'
        })
    else:
        selected_choice.votes += 1
        selected_choice.save()
    return HttpResponseRedirect(reverse('polls:results', args = (question.id,)))

def results(request, question_id):
    question = get_object_or_404(Question, pk = question_id)
    return render(request, 'polls/results.html', {'question': question})

def sign_in(request):
    if request.method == 'GET':
        if request.user.is_authenticated:
            return redirect('/polls/')
        
        form = LoginForm()
        return render(request, 'polls/login.html', {'form': form})
    
    elif request.method == 'POST':
        form = LoginForm(request.POST)

        if(form.is_valid()):
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(request, username = username, password = password)

            if user:
                login(request, user)
                messages.success(request, f'Hi {username.title()}, welcome back!')
                return redirect('polls:index')
            
        messages.error(request, f'Invalid username or password')
        return render(request,'polls/login.html',{'form': form})
    
def sign_out(request):
    logout(request)
    messages.success(request, f'You have been logged out.')
    return redirect('polls:login')

polls/templates/polls/detail.html
<form action="{% url 'polls:vote' question.id %}" method="post">
    {% csrf_token %}
    <fieldset>
        <legend>
            <h1>
                {{ question.question_text }}
            </h1>
        </legend>
        {% if error_message %}
            <p>
                <strong>
                    {{ error_message }}
                </strong>
            </p>
        {% endif %}
        {% for choice in question.choice_set.all %}
            <input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{ choice.id }}">
                <label for="choice{{ forloop.counter }}">
                    {{ choice.choice_text }}
                </label>
                <br>
                {% endfor %}
            </fieldset>
            <input type="submit" value="Vote">
        </form>
            

polls/templates/polls/index.html
{% extends 'base.html' %}
	
{% block content %}

    {% if latest_question_list %}
        <ul>
            {% for question in latest_question_list %}
                <li>
                    <a href="{% url 'polls:detail' question.id %}">
                        {{ question.question_text }}
                    </a>
                </li>
            {% endfor %}
        </ul>
    {% else %}
        <p>
            No polls are available.
        </p>
    {% endif %}
{% endblock content %}

polls/templates/polls/login.html
{% extends 'base.html' %}

{% block content %}
	<form method="POST" novalidate>
		{% csrf_token %}
		<h2>Login</h2>
		{{ form.as_p }}
		<input type="submit" value="Login" />
	</form>
{% endblock content %}

polls/templates/polls/results.html
<h1>
    {{ question.question_text }}
</h1>

<ul>
    {% for choice in question.choice_set.all %}
        <li>
            {{ choice.choice_text }}
            -- 
            {{ choice.votes }}
            vote
            {{ choice.votes|pluralize }}
        </li>
    {% endfor %}
</ul>

<a href="{% url 'polls:detail' question.id %}">
    Vote again?
</a>

templates/base.html
<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]>      <html class="no-js"> <!--<![endif]-->
{% load static %}
<html>
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <title></title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="">
    </head>
    <body>
        <header>    
            {% if request.user.is_authenticated %}
                <span>Hi {{ request.user.username | title }}</span>
                <a href="{% url 'polls:logout' %}">Logout</a>
            {% else %}
                <a href="{% url 'polls:login' %}">Login</a>
            {% endif %}
        </header>
        <main>
            {% if messages %}
                <div class="messages">
                {% for message in messages %}
                    <div class="alert {% if message.tags %}alert-{{ message.tags }}"{% endif %}>
                        {{ message }}
                    </div>
                {% endfor %}
                </div>
            {% endif %}
                
            {% block content %} 
            {% endblock content %}
        </main>
        <!--[if lt IE 7]>
            <p class="browsehappy">You are using an <strong>outdated</strong> browser. Please <a href="#">upgrade your browser</a> to improve your experience.</p>
        <![endif]-->
        
        <script src="" async defer></script>
    </body>
</html>